/* @(#)defaults.c	1.3 03/07/13 Copyright 1998-2003 J. Schilling */
#ifndef lint
static	char sccsid[] =
	"@(#)defaults.c	1.3 03/07/13 Copyright 1998-2003 J. Schilling";
#endif
/*
 *	Copyright (c) 1998-2003 J. Schilling
 */
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; see the file COPYING.  If not, write to the Free Software
 * Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <mconfig.h>
#include <stdxlib.h>
#include <unixstd.h>
#include <strdefs.h>
#include <stdio.h>
#include <standard.h>
#include <deflts.h>
#include <utypes.h>
#include <schily.h>
#include "starsubs.h"

LOCAL	int	open_cdrdefaults __PR((void));
EXPORT	void	star_defaults	__PR((long *fsp));

LOCAL int
open_cdrdefaults()
{
	/*
	 * WARNING you are only allowed to change this filename if you also
	 * change the documentation and add a statement that makes clear
	 * where the official location of the file is why you did choose a
	 * nonstandard location and that the nonstandard location only refers
	 * to inofficial star versions.
	 *
	 * I was forced to add this because some people change star without
	 * rational reason and then publish the result. As those people
	 * don't contribute work and don't give support, they are causing extra
	 * work for me and this way slow down the star development.
	 */
	return (defltopen("/etc/default/star"));
}

EXPORT void
star_defaults(fsp)
	long	*fsp;
{
	long	fs	= 0L;
	long	fs_max	= -1L;

	if (fsp != NULL)
		fs = *fsp;

	if (fs <= 0L) {
		char	*p = NULL;

		if (open_cdrdefaults() == 0) {
			p = defltread("STAR_FIFOSIZE=");
		}
		if (p) {
			if (getnum(p, &fs) != 1)
				comerrno(EX_BAD, "Bad fifo size default.\n");
		}
	}
	if (fs > 0L) {
		char	*p = NULL;

		if (open_cdrdefaults() == 0) {
			p = defltread("STAR_FIFOSIZE_MAX=");
		}
		if (p) {
			if (getnum(p, &fs_max) != 1) {
				comerrno(EX_BAD,
					"Bad max fifo size default.\n");
			}
		}
		if (fs > fs_max)
			fs = fs_max;
	}

	if (fs > 0L && fsp != NULL)
		*fsp = fs;

	defltclose();
}
